"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = CheckboxFilterGroup;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireWildcard(require("react"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _FormGroup = _interopRequireDefault(require("@material-ui/core/FormGroup"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _styles = require("@material-ui/core/styles");

var _SearchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));

var styles = function styles(theme) {
  return {
    matches: {
      marginLeft: '5px',
      display: 'inline'
    },
    groupLabel: {
      display: 'flex',
      alignItems: 'center'
    }
  };
};

var useStyles = (0, _styles.makeStyles)(styles, {
  name: 'RSFCheckboxFilterGroup'
});

function CheckboxFilterGroup(props) {
  var group = props.group,
      submitOnChange = props.submitOnChange;

  var _useContext = (0, _react.useContext)(_SearchResultsContext["default"]),
      filters = _useContext.pageData.filters,
      toggleFilter = _useContext.actions.toggleFilter;

  var classes = useStyles();
  return (0, _react.useMemo)(function () {
    return _react["default"].createElement(_FormGroup["default"], null, group.options.map(function (facet, i) {
      return _react["default"].createElement(_FormControlLabel["default"], {
        key: i,
        label: _react["default"].createElement("div", {
          className: classes.groupLabel
        }, _react["default"].createElement("span", null, facet.name), _react["default"].createElement(_Typography["default"], {
          variant: "caption",
          className: classes.matches,
          component: "span"
        }, "(", facet.matches, ")")),
        control: _react["default"].createElement(_Checkbox["default"], {
          checked: filters.indexOf(facet.code) !== -1,
          color: "primary",
          onChange: function onChange() {
            return toggleFilter(facet, submitOnChange);
          }
        })
      });
    }));
  }, [].concat((0, _toConsumableArray2["default"])(Object.values(props)), [filters]));
}
//# sourceMappingURL=CheckboxFilterGroup.js.map