"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.styles = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _ActionButton = _interopRequireDefault(require("../ActionButton"));

var _SearchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));

var _Filter = _interopRequireDefault(require("./Filter"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Drawer = _interopRequireDefault(require("../drawer/Drawer"));

var _styles = require("@material-ui/core/styles");

var _router = require("next/router");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var styles = function styles(theme) {
  return {
    drawer: {
      height: '75vh'
    }
  };
};

exports.styles = styles;
var useStyles = (0, _styles.makeStyles)(styles, {
  name: 'RSFFilterButton'
});
/**
 * A button that when clicked, opens a drawer containing the `Filter` view. Current filters
 * are displayed in the button text.
 */

function FilterButton(_ref) {
  var classes = _ref.classes,
      title = _ref.title,
      drawerProps = _ref.drawerProps,
      onClick = _ref.onClick,
      href = _ref.href,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["classes", "title", "drawerProps", "onClick", "href"]);
  classes = useStyles({
    classes: classes
  });

  var _useContext = (0, _react.useContext)(_SearchResultsContext["default"]),
      _useContext$pageData = _useContext.pageData,
      filters = _useContext$pageData.filters,
      facets = _useContext$pageData.facets,
      actions = _useContext.actions;

  var openFilter = (0, _router.useRouter)().query.openFilter === '1';

  var _useState = (0, _react.useState)({
    open: openFilter,
    loading: false,
    mountDrawer: openFilter
  }),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var open = state.open,
      mountDrawer = state.mountDrawer,
      loading = state.loading;

  var _useStyles = useStyles(classes),
      clear = _useStyles.clear,
      clearDisabled = _useStyles.clearDisabled,
      drawer = _useStyles.drawer,
      buttonClasses = (0, _objectWithoutProperties2["default"])(_useStyles, ["clear", "clearDisabled", "drawer"]);

  var toggleOpen = function toggleOpen(open) {
    setState(_objectSpread({}, state, {
      open: open,
      mountDrawer: mountDrawer || true
    }));
  };

  var handleClick = function handleClick(e) {
    if (onClick) {
      onClick(e);
    }

    if (!e.defaultPrevented) {
      toggleOpen(true);
    }
  };

  var handleViewResultsClick = (0, _react.useCallback)(function () {
    toggleOpen(false);
    actions.applyFilters();
  }, [actions]);

  var getFilterList = function getFilterList() {
    if (!filters || !facets || filters.length === 0) return null;
    if (filters.length > 1) return "".concat(filters.length, " selected");
    var selected = filters[0];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = facets[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var group = _step.value;
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = group.options[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var option = _step2.value;

            if (selected === option.code) {
              return option.name;
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
              _iterator2["return"]();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return null;
  };

  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_ActionButton["default"], (0, _extends2["default"])({
    label: title,
    href: href,
    value: getFilterList(),
    classes: buttonClasses,
    onClick: handleClick
  }, props)), !href && _react["default"].createElement(_Drawer["default"], {
    classes: {
      paper: classes.drawer
    },
    anchor: "bottom",
    open: open,
    onClose: toggleOpen.bind(null, false),
    ModalProps: {
      keepMounted: true
    }
  }, mountDrawer && _react["default"].createElement(_Filter["default"], (0, _extends2["default"])({
    onViewResultsClick: handleViewResultsClick
  }, drawerProps))));
}

FilterButton.propTypes = {
  /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */
  classes: _propTypes["default"].object,

  /**
   * Props for the underlying `Filter` component
   */
  drawerProps: _propTypes["default"].object,

  /**
   * The label for the button and the drawer header.  Defaults to "Filter".
   */
  title: _propTypes["default"].string,

  /**
   * When specified, clicking the button will navigate to the specified URL with a full page reload.
   */
  href: _propTypes["default"].string
};
FilterButton.defaultProps = {
  title: 'Filter',
  drawerProps: {}
};

var _default = (0, _react.memo)(FilterButton);

exports["default"] = _default;
//# sourceMappingURL=FilterButton.js.map