"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = sendApiVersionOnAllRequests;

/**
 * Here we send an rsf-api-version header whose value is the timestamp of the build
 * with all requests so that the service worker can make sure it only returns a cached
 * result from the same version of the application that is currently running.
 */
function sendApiVersionOnAllRequests() {
  if (typeof XMLHttpRequest !== 'undefined') {
    var open = XMLHttpRequest.prototype.open; //TODO Not working

    XMLHttpRequest.prototype.open = function () {
      var res = open.apply(this, arguments);
      this.setRequestHeader('x-rsf-api-version', process.env.RSF_API_VERSION || '1');
      return res;
    };
  }
}
//# sourceMappingURL=sendApiVersionOnAllRequests.js.map